# aiomarine ⚡
<a id="readme-top"></a> 

<div align="center">  
  <p align="center">
    Blazing fast async ORM/ODM in Python
    <br />
    <a href="https://alexeev-prog.github.io/aiomarine/"><strong>Explore the docs »</strong></a>
    <br />
    <br />
    <a href="#-why-choose-aiomarine">Why Choose aiomarine</a>
    ·
    <a href="#-key-features">Key Features</a>
    ·
    <a href="#-getting-started">Getting Started</a>
    ·
    <a href="#-usage-examples">Basic Usage</a>
    ·
    <a href="#-specifications">Specification</a>
    ·
    <a href="https://alexeev-prog.github.io/aiomarine/">Documentation</a>
    ·
    <a href="https://github.com/alexeev-prog/aiomarine/blob/main/LICENSE">License</a>
  </p>
</div>
<br>
<p align="center">
    <img src="https://img.shields.io/github/languages/top/alexeev-prog/aiomarine?style=for-the-badge">
    <img src="https://img.shields.io/github/languages/count/alexeev-prog/aiomarine?style=for-the-badge">
    <img src="https://img.shields.io/github/license/alexeev-prog/aiomarine?style=for-the-badge">
    <img src="https://img.shields.io/github/stars/alexeev-prog/aiomarine?style=for-the-badge">
    <img src="https://img.shields.io/github/issues/alexeev-prog/aiomarine?style=for-the-badge">
    <img src="https://img.shields.io/github/last-commit/alexeev-prog/aiomarine?style=for-the-badge">
    <img src="https://img.shields.io/pypi/wheel/uvolution?style=for-the-badge">
    <img src="https://img.shields.io/badge/coverage-73%25-73%25?style=for-the-badge" alt="">
    <img alt="PyPI - Downloads" src="https://img.shields.io/pypi/dm/aiomarine?style=for-the-badge">
    <img alt="PyPI - Version" src="https://img.shields.io/pypi/v/aiomarine?style=for-the-badge">
    <img alt="PyPI - Python Version" src="https://img.shields.io/pypi/pyversions/aiomarine?style=for-the-badge">
    <img alt="GitHub contributors" src="https://img.shields.io/github/contributors/alexeev-prog/aiomarine?style=for-the-badge">
</p>

<p align="center">
    <img src="https://raw.githubusercontent.com/alexeev-prog/aiomarine/refs/heads/main/docs/pallet-0.png">
</p>

 > Blazing fast async ORM/ODM in Python
 
Welcome to aiomarine – a cutting-edge framework that redefines how you interact with databases! 🌊 In today's fast-paced world, where data is paramount, having the right tool to manage both relational and NoSQL databases is essential. aiomarine combines the power of versatility, speed, and advanced functionality to give you an unparalleled development experience. 

Whether you're scaling web applications or managing complex data structures, aiomarine is designed to meet your every need. Let’s dive deeper into what makes this framework exceptional! 

 > [!CAUTION]
> At the moment, AIOMarine is under active development, many things may not work, and this version is not recommended for use (all at your own risk)

<p align="center">
    <img src="https://raw.githubusercontent.com/alexeev-prog/aiomarine/refs/heads/main/docs/logo.jpg" width="70%" height="70%" >
</p>

### 🌟 Key Features

aiomarine stands out from the plethora of ORM/ODM frameworks in the market due to its unique features and capabilities. Here’s a detailed breakdown of its most significant offerings:

| Feature                   | Description                                                                                          | Benefits                                          |
|---------------------------|------------------------------------------------------------------------------------------------------|--------------------------------------------------|
| 🔗 Cross-DB Compatibility | Effortlessly switch between relational and document-based databases using a unified API.          | Save time by using one framework for all needs!  |
| ⚡️ High Performance      | Optimized for speed with minimal latency, perfect for high-load applications.                       | Deliver faster responses and enhance user experience. |
| 🔍 Rich Functionality    | Comprehensive features including asynchronous programming, deep querying, and complex relationships. | Build sophisticated applications without complexity.    |
| 💼 User-Friendly Design  | Intuitive and accessible interface perfect for newbies and experienced developers alike.         | Reduce learning curve and boost productivity!     |
| 🔄 Seamless Migrations   | Built-in migration tools to manage schema migrations effortlessly and restore previous states.       | Maintain control over your database evolution easily. |

<p align="right">(<a href="#readme-top">back to top</a>)</p>

## 🤔 Why Choose aiomarine?

1. ✨ Asynchronous Access:
    - Utilize async/await for non-blocking database calls, enhancing application responsiveness.

2. 🔼 Advanced Relationships:
    - Handle one-to-one, one-to-many, and many-to-many relationships effortlessly.

3. 🧭 Structured Logging:
    - Built-in logging functionality to keep track of every transaction, making debugging easier.

4. 🔐 Security Features:
    - Implement strong security measures, including encryption and safe access control.

5. 📈 Analytics and Reporting:
    - Simplify the process of generating insights from your data with built-in analytics.

<p align="right">(<a href="#readme-top">back to top</a>)</p>

## Check Other My Projects

 + [aiomarine](https://github.com/alexeev-prog/aiomarine) - universal full-feature web framework in python
 + [Burn-Build](https://github.com/alexeev-prog/burn-build) - simple and fast build system written in python for C/C++ and other projects. With multiprocessing, project creation and caches!
 + [OptiArch](https://github.com/alexeev-prog/optiarch) - shell script for fast optimization of Arch Linux
 + [libnumerixpp](https://github.com/alexeev-prog/libnumerixpp) - a Powerful C++ Library for High-Performance Numerical Computing
 + [pycolor-palette](https://github.com/alexeev-prog/pycolor-palette) - display beautiful log messages, logging, debugging.
 + [shegang](https://github.com/alexeev-prog/shegang) - powerful command interpreter (shell) for linux written in C
 
<p align="right">(<a href="#readme-top">back to top</a>)</p>


<p align="right">(<a href="#readme-top">back to top</a>)</p>

## 🚀 Getting Started

AIOMarine is available on [PyPI](https://pypi.org/project/aiomarine). Simply install the package into your project environment with PIP:

```bash
pip install aiomarine
```

Once installed, you can start using the library in your Python projects. Check out the [documentation](https://alexeev-prog.github.io/aiomarine) for detailed usage examples and API reference.

<p align="right">(<a href="#readme-top">back to top</a>)</p>

## 💻 Usage Examples
You can view examples at [examples directory](./examples).

### 📖 Documentation Highlights

- Getting Started: Step-by-step guides to set up and configure your environment.
- API Reference: Detailed explanations of functions and methods available in aiomarine.
- Advanced Guides: Dive into best practices for performance optimization and advanced features.

For dynamic real-time updates and community-driven knowledge sharing, visit [aiomarine Documentation](https://alexeev-prog.github.io/aiomarine/) now! 

## 🔧 Specifications
Coming soon

<img src="https://github.com/alexeev-prog/aiomarine/actions/workflows/docs.yml/badge.svg">

## 🤝 Contributing
We welcome contributions from the community! If you'd like to help improve aiomarine, please check out the [contributing guidelines](https://github.com/alexeev-prog/aiomarine/blob/main/CONTRIBUTING.md) to get started.

aiomarine is an open-source project that thrives on community contributions! By getting involved, you’re not just enhancing your skills but helping fellow developers too. Here’s how you can participate:

1. Fork the Repository: Clone the project to your own GitHub account to make changes.
2. Create a Feature Branch: Always develop in a separate branch to keep the main branch stable.
3. Open a Pull Request: Once your feature or fix is ready, submit a PR for review!

Check our [CONTRIBUTING.md](CONTRIBUTING.md) file for detailed guidelines on how to contribute effectively. We value every contribution, whether it’s coding, writing documentation, or reporting issues! Every bit helps to foster a healthy community.

<p align="right">(<a href="#readme-top">back to top</a>)</p>

## 👥 Join the Community!
If you find aiomarine valuable and want to support the project:

- Star on GitHub ⭐
- Share it with friends and colleagues!
- Donate via cryptocurrency 🙌

Connect with fellow aiomarine users: [Join our Telegram Channel](https://t.me/hex_warehouse)

## 🔮 Roadmap
Our future goals for aiomarine include:

- 📚 Improve middlewares
- 🚀 Add async support
- ✅ Improve logging
- 🌍 Add MongoDB; PostgreSQL; MySQL; SQLite support
- 💻 Depedency Injection
- 🌐 More stability and scalablity

<p align="right">(<a href="#readme-top">back to top</a>)</p>

## 🌟 Get Started Today!
Unlock your potential as a developer with aiomarine. Don’t just build applications—craft experiences that resonate with your users! The possibilities are limitless when you harness the power of aiomarine. 

**Happy Coding!** 💻✨

This README is designed to grab attention from the very first lines. It emphasizes the framework's strengths and makes a compelling case for why developers should choose aiomarine for their projects. Feel free to adjust any specific links or images to fit your project!

## License
Distributed under the GNU LGPL 2.1 License. See [LICENSE](https://github.com/alexeev-prog/aiomarine/blob/main/LICENSE) for more information.

<p align="right">(<a href="#readme-top">back to top</a>)</p>
